Subject: bug#63800: 30.0.50; [ELPA] Inaccurate installation instructions for built-in packages

From: Ihor Radchenko <[email-masked]>
Date: Thu, 08 Jun 2023 11:01:12 +0000

Philip Kaludercic <[email-masked]> writes:

>>> You probably want to set `package-install-upgrade-built-in' to non-nil,
>>> or use the package menu to install packages.
>>
>> Sure. But only in Emacs >=29 and it is not mentioned on the ELPA page.
>
> I am not a fan of the option to begin with, and wouldn't want to
> advertise it.  The official way of switching from built-in packages to
> ELPA should still be to use the package menu.

I will not argue about this. This bug report merely raises the issue
with current installation instructions. You are in a better position to
recommend one or another way to install/upgrade core packages from ELPA.

>> For Emacs <29 ELPA instruction simply does not work - attempting to
>> follow it will just produce unhelpful message that package is already
>> installed.
>
> So what would you suggest changing?

I suggest changing

    To install this package, run in Emacs:
    
    M-x package-install RET <package-name> RET

to something like

   This package is a part of Emacs since Emacs XX.X.

   To install the package in Emacs <XX.X, run:

   M-x package-install RET <package-name

   To update the built-in package version in Emacs >=XX.X to ELPA version:
      
   <instructions to install the package that actually work>

-- 
Ihor Radchenko // yantar92,
Org mode contributor,
Learn more about Org mode at <https://orgmode.org/>.
Support Org development at <https://liberapay.com/org-mode>,
or support my work at <https://liberapay.com/yantar92>